/*
Arduino BlueTooth Not So Smart Watch, 
designed & engineered & programmed by Auer Markus 2014
markusauer88@gmail.com
Thans to 
my girlfriend Jaqueline ( for her patience and the Logo )
PJRC. com ( TimeLIB, SoftwareSerial )
adafruit .com ( OLED )
Arduino.cc ( for giving me the possibility to MAKE :-P ) 
All Makers out there ( for inspiration )
*/

#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#include <SoftwareSerial.h>
#include <Time.h>

Adafruit_SSD1306 display(4);

// Define Array for BMP
#define SMS_GLCD_HEIGHT 8 
#define SMS_GLCD_WIDTH  16 
static const unsigned char PROGMEM SMS_glcd_bmp[] =
{ B00000000, B00000000,
  B11111111, B11111111,
  B11110000, B00001111,
  B10001110, B01111001,
  B10000001, B10000001,
  B10000000, B00000001,
  B11111111, B11111111,
  B00000000, B00000000,
   };

#define CALL_GLCD_HEIGHT 8 
#define CALL_GLCD_WIDTH  16 
static const unsigned char PROGMEM CALL_glcd_bmp[] =
{ 
  B00000000, B00000000,
  B00011111, B11111000,
  B00111111, B11111100,
  B01111000, B00011110,
  B11111100, B00111111,
  B11111100, B00111111,
  B11111100, B00111111,
  B00000000, B00000000,
   };
//ABTNSSW LOGO, idea & Design, Jaqueline Thurnes
#define LOGO_GLCD_HEIGHT 16 
#define LOGO_GLCD_WIDTH  32 
static const unsigned char PROGMEM LOGO_glcd_bmp[] =
{ 
  B00000000, B00000000, B00000000, B00000000,
  B00000000, B00000000, B00000000, B00000000,
  B00000011, B10000111, B11110000, B01000000,
  B00001111, B00000111, B11110000, B01000000,
  B00011110, B00000010, B00100010, B01001000,
  B00111110, B00000001, B01000001, B11110000,
  B01111100, B00000001, B01000001, B11110000,
  B01111100, B00000000, B10000111, B11111110,
  B01111100, B00000000, B10000001, B11110000,
  B01111100, B00000001, B01000001, B11110000,
  B00111110, B00000001, B11000010, B01001000,
  B00011110, B00000011, B11100000, B01000000,
  B00001111, B00000111, B11110000, B01000000,
  B00000011, B10000111, B11110000, B00000000,
  B00000000, B00000000, B00000000, B00000000,
  B00000000, B00000000, B00000000, B00000000,
   };

SoftwareSerial BTSerial(2, 3); // RX, TX
// define Buttons, Protocol Headers & Trailers ...
#define TIME_MSG_LEN  11
#define TIME_HEADER  'T'
#define TIME_REQUEST  7
#define SMS2_HEADER '|'
#define SMS1_HEADER '$'
#define SMS0_HEADER '%'
#define SMSN_length 12
#define CALL2_HEADER '*'
#define CALL1_HEADER '?'
#define CALL0_HEADER '!'
#define GPS_HEADER '&'
#define button 4
#define rbutton 5

// MSG Array 1
char inData[16];
char inChar;
// Call Array 2
char inCall[16];
char inNumber;
//Define variables
byte index = 0;
long tmillis = 0;
long ptmillis = 0;
int ctimeout = 5000;
int count = 0;
int sms = 0;
int call = 0;
int gps = 0;
int alt = 0;
int spd = 0;
int bstat = 1;
int notifier = 1;
int timeout = 5000;

void setup()  
{ 
  pinMode(button, INPUT_PULLUP);
  pinMode(button, INPUT_PULLUP);
  //initialize Serial & Dispay
  Serial.begin(115200);
  BTSerial.begin(115200);
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C); //init. Display, clear it
  display.clearDisplay();
  display.display(); 
  //print "SplashScreen"
  display.setTextSize(3); // TextSize
  display.setTextColor(WHITE);
  display.setCursor(52,0); //x,y coordinates for Text
  display.print("ABTW");
  display.setCursor(0,28);
  display.drawBitmap(0,4,  LOGO_glcd_bmp, 32, 16, 1);//Print lBMP, (x,y, select BMP, SIZE x, SIZE y)
  display.setTextSize(0.5);
  display.setCursor(58,23);
  display.setTextColor(WHITE);
  display.print("Not");
  display.print("So");
  display.print("Smart");
  display.setTextSize(1);
  display.setCursor(0,32);
  display.print("Waiting for Timesync!");
  display.setCursor(0,46);
  display.print("ArduinoBlueToothWatch");
  display.setCursor(0,54);
  display.print("Version V0.2b (c)2014");
  display.display();
  delay(2500);
  //wait for Timesync
  while (timeStatus()!= timeSet) {
         timesync();
        }   
  }
  
  void timesync() //TimeLib Code
{
  while (Serial.available() >= TIME_MSG_LEN){
    char c = Serial.read();
    if (c == TIME_HEADER){
      time_t pctime = 0;
      for(int i=0; i < TIME_MSG_LEN -1; i++){
        c = Serial.read();
        if ( c >= '0' && c <= '9'){
         pctime = (10 * pctime) + (c - '0'); 
        }
    }
    setTime(pctime);
 }
}
}
  
void loop()
{ //check for resetpin (reset displ. Call & Msg)
  if (digitalRead(rbutton)==HIGH){
     sms=0;
     call=0;
     gps=0;
     }  
  //check if button is pressed or. MSg, Call received handle displaytimeout  
  if(digitalRead(button)==HIGH || bstat == 1 || notifier == 1) 
  { 
    bstat = 1;
    long tmillis = millis ();
    readBT();
    clock();
    if (tmillis - ptmillis > timeout) {
    ptmillis = millis();  
    bstat = 0;
    notifier = 0; 
    }
  } 
   //if nothing (button, MSg, Call, ...) is true, turn off display
   if ( notifier == 0 && bstat == 0 && digitalRead(button)==LOW)
   {
    display.clearDisplay();
    display.display();     
   } 
   //read from Serial Port
  readBT();
}

void clock ()
{ // Display TIME
  display.clearDisplay();
  display.setTextSize(3);
  display.setTextColor(WHITE);
  display.setCursor(20,0);
  //Display hour, print leading Zero
  if ( hour() <10 ) {
    display.print("0");
  }// Part from TimeLib Code
  display.print(hour());
  printDigits(minute());
  
  //Display Date
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.setCursor(6,26);
  display.print(dayStr(weekday()));
  display.setCursor(65,26);
  display.print(day());
  display.print (".");
  display.print(month());
  display.print (".");
  display.print(year());
  // Check for Status (returned from readBT)
  if (sms == 1) // Print if MSg is received
  {    
    display.setTextSize(1);
    display.setTextColor(WHITE);
    display.drawBitmap(6,46,  SMS_glcd_bmp, 16, 8, 1);
    display.setCursor(28,46);
    for ( int i = 0; i < sizeof(inData); i++){ //write Data to ARRAY, First ARRAY = 0 - x
       display.print(inData[i]);
    }
  }
  
   if (call == 1) //Print if call is Incomig or Outgoing
   {
    display.setTextSize(1);
    display.setTextColor(WHITE);
    display.drawBitmap(6,56,  CALL_glcd_bmp, 16, 8, 1);
    display.setCursor(28,56);
    for ( int i = 0; i < sizeof(inCall); i++){ //write Data to ARRAY, Second ARRAY = x - y (check first Array!)
       display.print(inData[i+16]);
    }
    }
if (gps = 1) // Print Data from Mobile GPS Sensor (Velocity not implemented @ the moment)
{
    display.setTextSize(1);
    display.setTextColor(WHITE);
    display.setCursor(6,36); 
    //display.print("V= "); 
    //display.print(gps);
    //display.print("km/h"); 
    display.setCursor(65,36); 
    display.print("Alt= "); 
    display.print(alt);
    display.print("m"); 
  }
    

// DISPLAY all of the above (OLED Lib)
display.display();
}

void readBT() // Handle received Data
{       
  while (Serial.available() > 0){
        char c = Serial.read();
        while (timeStatus()!= timeSet) { // sync Clock if timeSet false
        timesync();
        }  
        if(c == TIME_HEADER) { // Handle Packet for Time, see definitions
        timesync();
        }          
        if (c == SMS1_HEADER) // Handle Packet for SMS, see definitions
           {  
             memset(inData, 0, sizeof(inData)); //Clear old Data
             //bstat = 1;
             notifier = 1;
             sms = 1;         
             char c = Serial.readBytesUntil(SMS2_HEADER, inData, sizeof(inData)); //write Data to ARRAY
            }
        if (c == SMS0_HEADER || sms == 0) // Handle Packet for SMS RESET, see definitions
          {
           //bstat = 0;
           //notifier = 0;
           sms = 0; 
           memset(inData, 0, sizeof(inData)); //Clear old Data
          }
       
      if(c == CALL1_HEADER){ // Handle Packet for call, see definitions
          memset(inCall, 0, sizeof(inCall)); //Clear old Data
          //bstat = 1;
          notifier = 1;
          call = 1;
          char x = Serial.readBytesUntil(CALL2_HEADER, inCall, sizeof(inCall)); //write Data to ARRAY
         }   
      if(c == CALL0_HEADER || call == 0){ // Handle Packet for call reset, see definitions
          //bstat = 0;
          //notifier = 0;
          call = 0;
          memset(inCall, 0, sizeof(inCall)); //Clear old Data
         }  
        
        if(c == GPS_HEADER){ // Handle Packet for GPS INFO, see definitions
          gps = 1;
          alt = Serial.parseInt();
          spd = Serial.parseInt();
          } 
        Serial.flush();
        c = ' ';  
     }
 }
//TimeLib Code
void printDigits(int digits){
  display.print(":");
  if(digits < 10)
    display.print('0');
  display.print(digits);
}


